from docutils import nodes
import jinja2
from docutils.parsers.rst import Directive


CHAT_TEMPLATE = jinja2.Template(
    u"""
    <div id="rasa-chat-block"></div>
    """
)

# placeholder node for document graph
class chat_block_node(nodes.General, nodes.Element):
    pass


class ChatBlockDirective(Directive):
    required_arguments = 0

    option_spec = {}

    # this will execute when your directive is encountered
    # it will insert a button_node into the document that will
    # get visited during the build phase
    def run(self):
        env = self.state.document.settings.env
        app = env.app

        node = chat_block_node()
        return [node]


def html_chat_block_node(self, node):
    html = CHAT_TEMPLATE.render()
    self.body.append(html)
    raise nodes.SkipNode


def setup(app):
    app.add_node(chat_block_node, html=(html_chat_block_node, None))
    app.add_directive("chat-block", ChatBlockDirective)
